/* Gnome Darxite Control
 * 
 * Author: Manuel Clos
 * 
 * Darxite Author: Ashley Montanaro
 *
 * See AUTHORS for emails.
 */

#define GDCONTROL_VERSION "0.4"
#define AUTHOR "Manuel Clos"

#define DEBUG_MESSAGES
#define EXTRA_DEBUG_MESSAGES
//#define DEBUG_CODE

#include <config.h>
#include <gnome.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <pwd.h>

#include "../common/daemon.h"

GnomeMDI *mdi; /* The main window! */

#define NUM_TOOLBARS 3

GtkWidget *toolbar;


#define SIGPIPE 13

typedef struct
{
	gchar *id;
	gint   type;
	gboolean  type_ch;
	gboolean new;
//	gboolean update_fl;
	gchar *filename;
	gchar *local_path;
	gchar *activity;
	gboolean activity_ch;
	gint   percent;
	gchar *percent_str;
	gboolean percent_ch;
	gint   current_size;
	gboolean current_size_ch;
	gint   total_size;
	gboolean total_size_ch;
	gint   current_time;
	gboolean current_time_ch;
	gint   total_time;
	gchar *total_time_str;
	gboolean total_time_ch;
	gint   rate_overall;
	gboolean rate_overall_ch;
	gint   estimated_time;
	gboolean estimated_t_ch;
	gchar *url;
	gint   counter;
}FileInfo;

enum{
	PLAY,
	PAUSE,
	RESTART,
	CANCEL
};

enum{
	NORMAL,
	ERROR,
	CANCELATION,
	COMPLETION,
	IGNORE
};

int autostart_daemon;

GList *batch;
GList *completions;

GList *clists;
gint FileStatus; /*Do we need to do FileStatus calls?*/

gboolean startup;
gboolean updated;
gboolean shutdown_app;

/*Preferences*/
typedef struct _PropertyUI {
        GnomePropertyBox *pbox;
        GtkWidget *appearance_tab;
        GtkWidget *history_tab;
        GtkWidget *daemon_tab;
        GtkWidget *dnd_tab;
} PropertyUI;

extern GdkColor Blue, Red, Cyan, Green, Brown, White;

gboolean history_read;
